/*
 * File name: station.h
 * Date:      2013/10/13 20:08
 * Author:    Jan Faigl
 */

#ifndef __STATION_H__
#define __STATION_H__

#include <vector>

#include "coords.h"

namespace som {

   struct SStation {
      const int label;
      const Coords coords;
      const double penalty;

      int stepWinnerSelected;

      SStation(const int label, const Coords& pt, const double penalty = 0.0) : label(label), coords(pt), penalty(penalty), stepWinnerSelected(-1) {}
      ~SStation() {}

      inline double squared_distance(const Coords & c) const { return coords.squared_distance(c); }
   };

   typedef std::vector<SStation*> StationPtrVector;

} //end namespace som

#endif

/* end of station.h */
